<?php
/*******************************************************
Trovate questo e altri script su http://www.manuelmarangoni.it , descritti e commentati nei dettagli.

Autore: Manuel Marangoni
Data messa online dello script: 30 ottobre 2011

Tre funzioni complete per il controllo e la formattazione della data e dell’ora.
Nello specifico le funzioni trattano:
- inversione del formato della data
- controllo del formato della data
- controllo dell'inserimento dell'ora
*******************************************************/

/** Inverte il giorno e l'anno di una data passata; la data può essere passata con l'ora **/
function inverti_data($variabile){

	//se la lunghezza della data è maggiore di 10, allora è presente l'ora e
    //suddivide la data e l'ora in due stringhe diverse
	if(strlen($variabile)>10){
		$data_iniziale=substr($variabile, 0, 10);
		$ora=substr($variabile, 11);
	}else
		$data_iniziale=$variabile;

	//sostituisce lo slash con il trattino
	$data_iniziale=str_replace("/", "-", $data_iniziale);

	//separa i componenti della data in array, usando il trattino come elemento
    //separatore, quindi inverte l'anno con il giorno
	$vet=explode("-", $data_iniziale);
	$data_finale=$vet[2]."-".$vet[1]."-".$vet[0];

	//se era presente l'ora, l'aggiungo alla data modificata
	if(isset($ora))
		$data_finale.=" ".$ora;

	return $data_finale; 

}



/** Controlla che la data sia della forma gg-mm-aaaa **/
function data_inserimento($variabile){

	//sostituisce lo slash con il trattino
	$variabile=str_replace("/", "-", $variabile);

	//controlla che la data sia formattata secondo lo standard gg-mm-aaaa; in tal caso
    //continua con i controlli, altrimenti restituisce false ed esce dalla funzione
	if(preg_match("#^\d{2}-\d{2}-\d{4}$#",$variabile)){

		//separa i componenti della data in array, usando il trattino come elemento
        //separatore, quindi usa la funzione checkdate per controllarli
		$data=explode("-",$variabile);

		if(checkdate($data[1],$data[0],$data[2]))
			return true;
		else
			return false;

	}else{
		return false;
	}
}


/** Controlla l'inserimento dell'ora **/
function ora_inserimento($variabile){

	$lenght=strlen($variabile);

	//considera il caso in cui nell'ora siano presenti o meno i secondi;
    //in base a questo saranno fatti controlli diversi
	if( ($lenght==8 and preg_match("#^\d{2}:\d{2}:\d{2}$#", $variabile)) or ($lenght==5 and preg_match("#^\d{2}:\d{2}$#", $variabile)) ){

		//separa i componenti della data in array, usando i due punti come elemento separatore
		$ora_arr=explode(":", $variabile);

		//controllo che i secondi siano in un range tra 0 e 59
		if($lenght==8 and ($ora_arr[2]<0 or $ora_arr[2]>60))
			return false;

		//controllo ora (range tra 0 e 23) e minuti (range tra 0 e 59)
		if($ora_arr[0]>=0 and $ora_arr[0]<24 and $ora_arr[1]>=0 and $ora_arr[1]<60)
			return true;
		else
			return false;

	}else{
		return false;
	}
}